package controller;

import com.github.cliftonlabs.json_simple.JsonKey;
import com.github.cliftonlabs.json_simple.JsonObject;
import model.questionnaire.Answer;
import model.questionnaire.Question;
import model.questionnaire.Session;
import java.util.UUID;

import static api.JsonKeys.KEY_ANSWER;
import static api.JsonKeys.KEY_QUESTION;

public class SessionController extends ModelController {

    public JsonObject get(JsonObject iJsonObject) {
        return new Session().asJsonObject();
    }

    public JsonObject getEntriesForId(String iId, JsonObject iBody) {
        Session vSession = Session.getSessionForUUID(UUID.fromString(iId));
        return vSession.asJsonObject();
    }

    public JsonObject updateEntry(String iID, JsonObject iBody) throws Exception{
        Session vSession = Session.getSessionForUUID(UUID.fromString(iID));
        if(null == vSession)
            throw new Exception(String.format("No session for UUID %s", iID));

        String vQuestionId = iBody.getString(KEY_QUESTION);
        String vAnswerId   = iBody.getString(KEY_ANSWER);
        Question vQuestion = Question.getForUUID(UUID.fromString(vQuestionId));
        if(null == vQuestion)
            throw new Exception(String.format("No question for UUID %s",vQuestionId));
        Answer vAnswer = vQuestion.getAnswerForUUID(UUID.fromString(vAnswerId));
        if(null == vAnswer)
            throw new Exception(String.format("No answer at index %d", vAnswerId));

        vSession.getSessionAnswers().setAnswer(vQuestion, vAnswer);
        System.out.println(vSession.asJsonObject().toString());
        return new JsonObject();
    }

}
